diff --git a/src/bin/pg_dump/t/002_pg_dump.pl b/src/bin/pg_dump/t/002_pg_dump.pl
index 9258948b583..642d16cac2f 100644
--- a/src/bin/pg_dump/t/002_pg_dump.pl
+++ b/src/bin/pg_dump/t/002_pg_dump.pl
@@ -3976,6 +3976,89 @@ my %tests = (
 		},
 	},
 
+	'CREATE INDEX ... INVISIBLE' => {
+		create_order => 98,
+		create_sql => 'CREATE TABLE dump_test.test_invisible_idx_table (
+							 id int,
+							 v int
+						   );
+						   CREATE INDEX test_invisible_idx
+							 ON dump_test.test_invisible_idx_table(v) INVISIBLE;',
+		regexp => qr/^
+			\QCREATE INDEX test_invisible_idx ON dump_test.test_invisible_idx_table USING btree (v) INVISIBLE;\E
+			/xm,
+		like => { %full_runs, %dump_test_schema_runs, section_post_data => 1 },
+		unlike => { exclude_dump_test_schema => 1, only_dump_measurement => 1 },
+	},
+
+	'ALTER INDEX ... INVISIBLE for primary key' => {
+		create_order => 98,
+		create_sql => 'CREATE TABLE dump_test.test_invisible_pk_table (
+							 id int PRIMARY KEY
+						   );
+						   ALTER INDEX dump_test.test_invisible_pk_table_pkey INVISIBLE;',
+		regexp => qr/^
+			\QALTER TABLE ONLY dump_test.test_invisible_pk_table\E\n\s+
+			\QADD CONSTRAINT test_invisible_pk_table_pkey PRIMARY KEY (id);\E\n
+			\QALTER INDEX dump_test.test_invisible_pk_table_pkey INVISIBLE;\E
+			/xm,
+		like => { %full_runs, %dump_test_schema_runs, section_post_data => 1 },
+		unlike => { exclude_dump_test_schema => 1, only_dump_measurement => 1 },
+	},
+
+	'CREATE INDEX ... INVISIBLE on partitioned table (parent)' => {
+		create_order => 98,
+		create_sql => 'CREATE TABLE dump_test.test_invisible_partidx (
+							 a int,
+							 b int
+						   ) PARTITION BY RANGE (a);
+						   CREATE TABLE dump_test.test_invisible_partidx_p1
+							 PARTITION OF dump_test.test_invisible_partidx
+							 FOR VALUES FROM (0) TO (100);
+						   CREATE TABLE dump_test.test_invisible_partidx_p2
+							 PARTITION OF dump_test.test_invisible_partidx
+							 FOR VALUES FROM (100) TO (200);
+						   CREATE INDEX test_invisible_partidx_a_idx
+							 ON dump_test.test_invisible_partidx(a) INVISIBLE;',
+		regexp => qr/^
+			\QCREATE INDEX test_invisible_partidx_a_idx ON ONLY dump_test.test_invisible_partidx USING btree (a) INVISIBLE;\E
+			/xm,
+		like => { %full_runs, %dump_test_schema_runs, section_post_data => 1 },
+		unlike => { exclude_dump_test_schema => 1, only_dump_measurement => 1 },
+	},
+
+	'CREATE INDEX ... INVISIBLE on partitioned table (child)' => {
+		create_order => 99,
+		create_sql => '',
+		regexp => qr/^
+			\QCREATE INDEX test_invisible_partidx_p1_a_idx ON dump_test.test_invisible_partidx_p1 USING btree (a) INVISIBLE;\E
+			/xm,
+		like => { %full_runs, %dump_test_schema_runs, section_post_data => 1 },
+		unlike => { exclude_dump_test_schema => 1, only_dump_measurement => 1 },
+	},
+
+	'CREATE INDEX leaf-only INVISIBLE on partition' => {
+		create_order => 98,
+		create_sql => 'CREATE TABLE dump_test.test_invisible_leaf (
+							 a int
+						   ) PARTITION BY RANGE (a);
+						   CREATE TABLE dump_test.test_invisible_leaf_p1
+							 PARTITION OF dump_test.test_invisible_leaf
+							 FOR VALUES FROM (0) TO (100);
+						   CREATE TABLE dump_test.test_invisible_leaf_p2
+							 PARTITION OF dump_test.test_invisible_leaf
+							 FOR VALUES FROM (100) TO (200);
+						   CREATE INDEX test_invisible_leaf_a_idx
+							 ON dump_test.test_invisible_leaf(a);
+						   ALTER INDEX dump_test.test_invisible_leaf_p1_a_idx
+							 INVISIBLE;',
+		regexp => qr/^
+			\QCREATE INDEX test_invisible_leaf_p1_a_idx ON dump_test.test_invisible_leaf_p1 USING btree (a) INVISIBLE;\E
+			/xm,
+		like => { %full_runs, %dump_test_schema_runs, section_post_data => 1 },
+		unlike => { exclude_dump_test_schema => 1, only_dump_measurement => 1 },
+	},
+
 	'CREATE TABLE test_inheritance_parent' => {
 		create_order => 90,
 		create_sql => 'CREATE TABLE dump_test.test_inheritance_parent (
@@ -5374,6 +5457,177 @@ foreach my $run (sort keys %pgdump_runs)
 	}
 }
 
+#########################################
+# Round-trip test: dump and restore a database that mixes invisible-index
+# states across plain, constraint-backed, partitioned-parent, attached
+# child, and leaf-only-overridden indexes, then verify pg_index.indisvisible
+# is preserved exactly on the restored side.  This is the strongest
+# guarantee pg_dump can give for this feature; the regex-only tests above
+# only check that the expected DDL fragments appear in the dump output.
+
+$node->safe_psql('postgres', q{
+    CREATE DATABASE invvis_src;
+    CREATE DATABASE invvis_dst;
+});
+
+$node->safe_psql('invvis_src', q{
+    -- 1. Plain invisible index
+    CREATE TABLE plain_t(a int);
+    CREATE INDEX plain_t_idx ON plain_t(a) INVISIBLE;
+
+    -- 2. Constraint-backed (PRIMARY KEY) invisible index, also used as
+    -- replica identity.  REPLICA IDENTITY USING INDEX and INVISIBLE are
+    -- independent catalog properties: indisvisible only affects planner
+    -- visibility, not replica-identity selection.  Both must survive
+    -- dump/restore.
+    CREATE TABLE pk_t(a int PRIMARY KEY);
+    ALTER TABLE pk_t REPLICA IDENTITY USING INDEX pk_t_pkey;
+    ALTER INDEX pk_t_pkey INVISIBLE;
+
+    -- 3. & 4. Partitioned parent + attached children invisible
+    CREATE TABLE part_t(a int, b int, c int) PARTITION BY RANGE (a);
+    CREATE TABLE part_t_p1 PARTITION OF part_t FOR VALUES FROM (0) TO (100);
+    CREATE TABLE part_t_p2 PARTITION OF part_t FOR VALUES FROM (100) TO (200);
+    CREATE INDEX part_t_a_idx ON part_t(a) INVISIBLE;
+
+    -- 5. Leaf-only override on an otherwise-visible partitioned hierarchy
+    CREATE INDEX part_t_b_idx ON part_t(b);
+    ALTER INDEX part_t_p1_b_idx INVISIBLE;
+
+    -- 6. Unrelated visible index hierarchy on the same partitioned table.
+    -- Use a plain column so child names are deterministic
+    -- (part_t_p1_c_idx, part_t_p2_c_idx).
+    CREATE INDEX part_t_c_idx ON part_t(c);
+
+    -- 7. Partitioned constraint-backed (PRIMARY KEY) invisible index.
+    -- pg_dump restores this through ALTER TABLE ... ADD CONSTRAINT, so
+    -- the invisible state must be preserved by emitting an explicit
+    -- ALTER INDEX ... INVISIBLE on the parent constraint-backed index.
+    -- The recursion in ATExecSetIndexVisibility then propagates that to
+    -- every child *_pkey index in the hierarchy.
+    CREATE TABLE part_pk_invis_t (
+        a int NOT NULL,
+        b text,
+        PRIMARY KEY (a)
+    ) PARTITION BY RANGE (a);
+    CREATE TABLE part_pk_invis_t_p1
+        PARTITION OF part_pk_invis_t FOR VALUES FROM (0) TO (100);
+    CREATE TABLE part_pk_invis_t_p2
+        PARTITION OF part_pk_invis_t FOR VALUES FROM (100) TO (200);
+    ALTER INDEX part_pk_invis_t_pkey INVISIBLE;
+
+    -- Sanity check: PK enforcement still works while the backing index
+    -- hierarchy is invisible.  We just exercise it; the round-trip
+    -- assertion below covers catalog state after restore.
+    INSERT INTO part_pk_invis_t VALUES (1, 'one'), (101, 'a hundred one');
+});
+
+$node->command_ok(
+	[
+		'pg_dump',
+		'--port' => $node->port,
+		'--dbname' => 'invvis_src',
+		'--file' => "$tempdir/invvis.sql",
+	],
+	'invisible-index round-trip: dump');
+
+$node->command_ok(
+	[
+		'psql',
+		'--port' => $node->port,
+		'--dbname' => 'invvis_dst',
+		'--file' => "$tempdir/invvis.sql",
+	],
+	'invisible-index round-trip: restore');
+
+my $invvis_actual = $node->safe_psql(
+	'invvis_dst', q{
+    WITH parents(oid, label) AS (
+        SELECT c.oid, c.relname FROM pg_class c
+         WHERE c.relname IN ('plain_t_idx',
+                             'pk_t_pkey',
+                             'part_t_a_idx',
+                             'part_t_b_idx',
+                             'part_t_c_idx',
+                             'part_pk_invis_t_pkey')
+    )
+    SELECT
+        CASE
+          WHEN c.relname = 'plain_t_idx'    THEN 'plain'
+          WHEN c.relname = 'pk_t_pkey'      THEN 'pkey'
+          ELSE coalesce(p.label, p2.label) || ':' ||
+               CASE WHEN p.label IS NOT NULL THEN 'parent' ELSE 'child' END
+        END AS slot,
+        c.relname,
+        i.indisvisible::text
+    FROM pg_index i
+    JOIN pg_class c ON c.oid = i.indexrelid
+    LEFT JOIN parents p  ON p.oid = c.oid
+    LEFT JOIN pg_inherits inh ON inh.inhrelid = c.oid
+    LEFT JOIN parents p2 ON p2.oid = inh.inhparent
+    WHERE p.oid IS NOT NULL OR p2.oid IS NOT NULL
+    ORDER BY slot, c.relname;
+});
+
+my $invvis_expected = join("\n", (
+	'part_pk_invis_t_pkey:child|part_pk_invis_t_p1_pkey|false',
+	'part_pk_invis_t_pkey:child|part_pk_invis_t_p2_pkey|false',
+	'part_pk_invis_t_pkey:parent|part_pk_invis_t_pkey|false',
+	'part_t_a_idx:child|part_t_p1_a_idx|false',
+	'part_t_a_idx:child|part_t_p2_a_idx|false',
+	'part_t_a_idx:parent|part_t_a_idx|false',
+	'part_t_b_idx:child|part_t_p1_b_idx|false',
+	'part_t_b_idx:child|part_t_p2_b_idx|true',
+	'part_t_b_idx:parent|part_t_b_idx|true',
+	'part_t_c_idx:child|part_t_p1_c_idx|true',
+	'part_t_c_idx:child|part_t_p2_c_idx|true',
+	'part_t_c_idx:parent|part_t_c_idx|true',
+	'pkey|pk_t_pkey|false',
+	'plain|plain_t_idx|false',
+));
+
+is($invvis_actual, $invvis_expected,
+	'invisible-index round-trip: pg_index.indisvisible matches across dump/restore for plain, constraint-backed, partitioned parent, attached children, leaf-only override, partitioned constraint-backed, and unrelated indexes'
+);
+
+# REPLICA IDENTITY + invisible coexistence after restore: pk_t_pkey was
+# created as PRIMARY KEY, marked REPLICA IDENTITY USING INDEX, then made
+# INVISIBLE in the source database.  After dump/restore, both
+# indisreplident = true and indisvisible = false must be preserved
+# independently: indisvisible is a planner-only flag and does not affect
+# replica-identity selection.
+my $invvis_replident_actual = $node->safe_psql(
+	'invvis_dst', q{
+    SELECT c.relname, i.indisvisible, i.indisreplident
+    FROM pg_index i
+    JOIN pg_class c ON c.oid = i.indexrelid
+    WHERE c.relname = 'pk_t_pkey'
+    ORDER BY c.relname;
+});
+
+is($invvis_replident_actual,
+	'pk_t_pkey|f|t',
+	'invisible-index round-trip: REPLICA IDENTITY USING INDEX and indisvisible=false coexist and survive dump/restore on pk_t_pkey'
+);
+
+# Constraint enforcement after restore on the partitioned PK hierarchy
+# whose backing indexes are invisible: the duplicate must still be
+# rejected even though every index in the hierarchy is hidden from the
+# planner.
+my ($pk_dup_ret, $pk_dup_stdout, $pk_dup_stderr) = $node->psql(
+	'invvis_dst',
+	"INSERT INTO part_pk_invis_t VALUES (1, 'duplicate');");
+isnt($pk_dup_ret, 0,
+	'invisible-index round-trip: PK still rejects duplicates even when the constraint-backed index hierarchy is invisible'
+);
+like($pk_dup_stderr, qr/duplicate key value violates unique constraint/,
+	'invisible-index round-trip: duplicate insert fails with unique violation');
+
+$node->safe_psql('postgres', q{
+    DROP DATABASE invvis_src;
+    DROP DATABASE invvis_dst;
+});
+
 #########################################
 # Stop the database instance, which will be removed at the end of the tests.
 
diff --git a/src/bin/psql/describe.c b/src/bin/psql/describe.c
index af3935b0078..3fc3703b20a 100644
--- a/src/bin/psql/describe.c
+++ b/src/bin/psql/describe.c
@@ -2471,6 +2471,11 @@ describeOneTableDetails(const char *schemaname,
 		else
 			appendPQExpBufferStr(&buf, "false AS indnullsnotdistinct,\n");
 
+		if (pset.sversion >= 190000)
+			appendPQExpBufferStr(&buf, "i.indisvisible,\n");
+		else
+			appendPQExpBufferStr(&buf, "true AS indisvisible,\n");
+
 		appendPQExpBuffer(&buf, "  a.amname, c2.relname, "
 						  "pg_catalog.pg_get_expr(i.indpred, i.indrelid, true)\n"
 						  "FROM pg_catalog.pg_index i, pg_catalog.pg_class c, pg_catalog.pg_class c2, pg_catalog.pg_am a\n"
@@ -2496,9 +2501,10 @@ describeOneTableDetails(const char *schemaname,
 			char	   *deferred = PQgetvalue(result, 0, 5);
 			char	   *indisreplident = PQgetvalue(result, 0, 6);
 			char	   *indnullsnotdistinct = PQgetvalue(result, 0, 7);
-			char	   *indamname = PQgetvalue(result, 0, 8);
-			char	   *indtable = PQgetvalue(result, 0, 9);
-			char	   *indpred = PQgetvalue(result, 0, 10);
+			char	   *indisvisible = PQgetvalue(result, 0, 8);
+			char	   *indamname = PQgetvalue(result, 0, 9);
+			char	   *indtable = PQgetvalue(result, 0, 10);
+			char	   *indpred = PQgetvalue(result, 0, 11);
 
 			if (strcmp(indisprimary, "t") == 0)
 				printfPQExpBuffer(&tmpbuf, _("primary key, "));
@@ -2535,6 +2541,9 @@ describeOneTableDetails(const char *schemaname,
 			if (strcmp(indisreplident, "t") == 0)
 				appendPQExpBufferStr(&tmpbuf, _(", replica identity"));
 
+			if (strcmp(indisvisible, "t") != 0)
+				appendPQExpBufferStr(&tmpbuf, _(", invisible"));
+
 			printTableAddFooter(&cont, tmpbuf.data);
 
 			/*
@@ -2578,6 +2587,10 @@ describeOneTableDetails(const char *schemaname,
 				appendPQExpBufferStr(&buf, ", con.conperiod");
 			else
 				appendPQExpBufferStr(&buf, ", false AS conperiod");
+			if (pset.sversion >= 190000)
+				appendPQExpBufferStr(&buf, ", i.indisvisible");
+			else
+				appendPQExpBufferStr(&buf, ", true AS indisvisible");
 			appendPQExpBuffer(&buf,
 							  "\nFROM pg_catalog.pg_class c, pg_catalog.pg_class c2, pg_catalog.pg_index i\n"
 							  "  LEFT JOIN pg_catalog.pg_constraint con ON (conrelid = i.indrelid AND conindid = i.indexrelid AND contype IN ("
@@ -2616,6 +2629,10 @@ describeOneTableDetails(const char *schemaname,
 					{
 						const char *indexdef;
 						const char *usingpos;
+						bool		indisvisible;
+						const char *invisible_suffix = " INVISIBLE";
+						const size_t invisible_suffix_len = strlen(invisible_suffix);
+						size_t		defLen;
 
 						/* Label as primary key or unique (but not both) */
 						if (strcmp(PQgetvalue(result, i, 1), "t") == 0)
@@ -2633,7 +2650,27 @@ describeOneTableDetails(const char *schemaname,
 						usingpos = strstr(indexdef, " USING ");
 						if (usingpos)
 							indexdef = usingpos + 7;
-						appendPQExpBuffer(&buf, " %s", indexdef);
+
+						/*
+						 * pg_get_indexdef() appends " INVISIBLE" for invisible
+						 * indexes (SQL deparse style).  Strip it here so we
+						 * can render the same information with the descriptive
+						 * "invisible" annotation below, matching the style
+						 * \d uses for an index relation directly.
+						 */
+						indisvisible = (strcmp(PQgetvalue(result, i, 13), "t") == 0);
+						defLen = strlen(indexdef);
+						if (!indisvisible &&
+							defLen >= invisible_suffix_len &&
+							strcmp(indexdef + defLen - invisible_suffix_len,
+								   invisible_suffix) == 0)
+						{
+							appendPQExpBufferChar(&buf, ' ');
+							appendBinaryPQExpBuffer(&buf, indexdef,
+													defLen - invisible_suffix_len);
+						}
+						else
+							appendPQExpBuffer(&buf, " %s", indexdef);
 
 						/* Need these for deferrable PK/UNIQUE indexes */
 						if (strcmp(PQgetvalue(result, i, 8), "t") == 0)
@@ -2641,6 +2678,9 @@ describeOneTableDetails(const char *schemaname,
 
 						if (strcmp(PQgetvalue(result, i, 9), "t") == 0)
 							appendPQExpBufferStr(&buf, " INITIALLY DEFERRED");
+
+						if (!indisvisible)
+							appendPQExpBufferStr(&buf, ", invisible");
 					}
 
 					/* Add these for all cases */
diff --git a/src/bin/psql/tab-complete.in.c b/src/bin/psql/tab-complete.in.c
index de547a8cb37..bd78ee29d11 100644
--- a/src/bin/psql/tab-complete.in.c
+++ b/src/bin/psql/tab-complete.in.c
@@ -2500,7 +2500,8 @@ match_previous_words(int pattern_id,
 	else if (Matches("ALTER", "INDEX", MatchAny))
 		COMPLETE_WITH("ALTER COLUMN", "OWNER TO", "RENAME TO", "SET",
 					  "RESET", "ATTACH PARTITION",
-					  "DEPENDS ON EXTENSION", "NO DEPENDS ON EXTENSION");
+					  "DEPENDS ON EXTENSION", "NO DEPENDS ON EXTENSION",
+					  "VISIBLE", "INVISIBLE");
 	else if (Matches("ALTER", "INDEX", MatchAny, "ATTACH"))
 		COMPLETE_WITH("PARTITION");
 	else if (Matches("ALTER", "INDEX", MatchAny, "ATTACH", "PARTITION"))
diff --git a/src/include/catalog/catversion.h b/src/include/catalog/catversion.h
index c4e94a3a09e..7f31a8a1548 100644
--- a/src/include/catalog/catversion.h
+++ b/src/include/catalog/catversion.h
@@ -57,6 +57,6 @@
  */
 
 /*							yyyymmddN */
-#define CATALOG_VERSION_NO	202606091
+#define CATALOG_VERSION_NO	202606151
 
 #endif
diff --git a/src/include/catalog/index.h b/src/include/catalog/index.h
index 9aee8226347..6b2153a388e 100644
--- a/src/include/catalog/index.h
+++ b/src/include/catalog/index.h
@@ -72,6 +72,7 @@ extern void index_check_primary_key(Relation heapRel,
 #define	INDEX_CREATE_PARTITIONED			(1 << 5)
 #define INDEX_CREATE_INVALID				(1 << 6)
 #define INDEX_CREATE_SUPPRESS_PROGRESS		(1 << 7)
+#define INDEX_CREATE_INVISIBLE				(1 << 8)
 
 extern Oid	index_create(Relation heapRelation,
 						 const char *indexRelationName,
diff --git a/src/include/catalog/pg_index.h b/src/include/catalog/pg_index.h
index d722efe49b4..b9d2cae4da3 100644
--- a/src/include/catalog/pg_index.h
+++ b/src/include/catalog/pg_index.h
@@ -46,6 +46,8 @@ CATALOG(pg_index,2610,IndexRelationId) BKI_SCHEMA_MACRO
 	bool		indisready;		/* is this index ready for inserts? */
 	bool		indislive;		/* is this index alive at all? */
 	bool		indisreplident; /* is this index the identity for replication? */
+	bool		indisvisible BKI_DEFAULT(t);	/* is this index visible to the
+												 * planner? */
 
 	/* variable-length fields start here, but we allow direct access to indkey */
 	int2vector	indkey BKI_FORCE_NOT_NULL;	/* column numbers of indexed cols,
diff --git a/src/include/nodes/parsenodes.h b/src/include/nodes/parsenodes.h
index 4133c404a6b..3b5783cae6c 100644
--- a/src/include/nodes/parsenodes.h
+++ b/src/include/nodes/parsenodes.h
@@ -2586,6 +2586,8 @@ typedef enum AlterTableType
 	AT_SetIdentity,				/* SET identity column options */
 	AT_DropIdentity,			/* DROP IDENTITY */
 	AT_ReAddStatistics,			/* internal to commands/tablecmds.c */
+	AT_SetIndexVisible,			/* ALTER INDEX VISIBLE */
+	AT_SetIndexInvisible,		/* ALTER INDEX INVISIBLE */
 } AlterTableType;
 
 typedef struct AlterTableCmd	/* one subcommand of an ALTER TABLE */
@@ -3616,6 +3618,8 @@ typedef struct IndexStmt
 	bool		if_not_exists;	/* just do nothing if index already exists? */
 	bool		reset_default_tblspc;	/* reset default_tablespace prior to
 										 * executing */
+	bool		isvisible;		/* true if VISIBLE (default), false if
+								 * INVISIBLE */
 } IndexStmt;
 
 /* ----------------------
diff --git a/src/include/parser/kwlist.h b/src/include/parser/kwlist.h
index 51ead54f015..455c6b2d649 100644
--- a/src/include/parser/kwlist.h
+++ b/src/include/parser/kwlist.h
@@ -234,6 +234,7 @@ PG_KEYWORD("integer", INTEGER, COL_NAME_KEYWORD, BARE_LABEL)
 PG_KEYWORD("intersect", INTERSECT, RESERVED_KEYWORD, AS_LABEL)
 PG_KEYWORD("interval", INTERVAL, COL_NAME_KEYWORD, BARE_LABEL)
 PG_KEYWORD("into", INTO, RESERVED_KEYWORD, AS_LABEL)
+PG_KEYWORD("invisible", INVISIBLE, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("invoker", INVOKER, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("is", IS, TYPE_FUNC_NAME_KEYWORD, BARE_LABEL)
 PG_KEYWORD("isnull", ISNULL, TYPE_FUNC_NAME_KEYWORD, AS_LABEL)
@@ -509,6 +510,7 @@ PG_KEYWORD("vertex", VERTEX, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("view", VIEW, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("views", VIEWS, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("virtual", VIRTUAL, UNRESERVED_KEYWORD, BARE_LABEL)
+PG_KEYWORD("visible", VISIBLE, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("volatile", VOLATILE, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("wait", WAIT, UNRESERVED_KEYWORD, BARE_LABEL)
 PG_KEYWORD("when", WHEN, RESERVED_KEYWORD, BARE_LABEL)
diff --git a/src/include/utils/lsyscache.h b/src/include/utils/lsyscache.h
index 865980cb0f1..08600df4269 100644
--- a/src/include/utils/lsyscache.h
+++ b/src/include/utils/lsyscache.h
@@ -212,6 +212,7 @@ extern Oid	get_index_column_opclass(Oid index_oid, int attno);
 extern bool get_index_isreplident(Oid index_oid);
 extern bool get_index_isvalid(Oid index_oid);
 extern bool get_index_isclustered(Oid index_oid);
+extern bool get_index_visibility(Oid index_oid);
 extern Oid	get_publication_oid(const char *pubname, bool missing_ok);
 extern char *get_publication_name(Oid pubid, bool missing_ok);
 extern Oid	get_subscription_oid(const char *subname, bool missing_ok);
diff --git a/src/test/modules/test_ddl_deparse/Makefile b/src/test/modules/test_ddl_deparse/Makefile
index f91a78d8d92..17ad1c0a33b 100644
--- a/src/test/modules/test_ddl_deparse/Makefile
+++ b/src/test/modules/test_ddl_deparse/Makefile
@@ -28,7 +28,8 @@ REGRESS = test_ddl_deparse \
 	opfamily \
 	defprivs \
 	textsearch \
-	matviews
+	matviews \
+	alter_index
 
 EXTRA_INSTALL = contrib/pg_stat_statements
 
diff --git a/src/test/modules/test_ddl_deparse/meson.build b/src/test/modules/test_ddl_deparse/meson.build
index 85decdf1f2b..95d2db3606a 100644
--- a/src/test/modules/test_ddl_deparse/meson.build
+++ b/src/test/modules/test_ddl_deparse/meson.build
@@ -49,6 +49,7 @@ tests += {
       'defprivs',
       'textsearch',
       'matviews',
+      'alter_index',
     ],
   },
 }
diff --git a/src/test/modules/test_ddl_deparse/sql/alter_index.sql b/src/test/modules/test_ddl_deparse/sql/alter_index.sql
new file mode 100644
index 00000000000..67e3243b762
--- /dev/null
+++ b/src/test/modules/test_ddl_deparse/sql/alter_index.sql
@@ -0,0 +1,24 @@
+--
+-- ALTER_INDEX
+--
+
+CREATE TABLE alter_idx_t (a int);
+CREATE INDEX alter_idx_t_a_idx ON alter_idx_t (a);
+
+ALTER INDEX alter_idx_t_a_idx INVISIBLE;
+ALTER INDEX alter_idx_t_a_idx VISIBLE;
+
+-- IF EXISTS form, on a missing index: no DDL command fires
+ALTER INDEX IF EXISTS alter_idx_t_does_not_exist INVISIBLE;
+
+-- Recursive form on a partitioned index
+CREATE TABLE alter_idx_part (a int) PARTITION BY RANGE (a);
+CREATE TABLE alter_idx_part_p1
+    PARTITION OF alter_idx_part FOR VALUES FROM (0) TO (100);
+CREATE INDEX alter_idx_part_a_idx ON alter_idx_part (a);
+
+ALTER INDEX alter_idx_part_a_idx INVISIBLE;
+ALTER INDEX alter_idx_part_a_idx VISIBLE;
+
+DROP TABLE alter_idx_part;
+DROP TABLE alter_idx_t;
diff --git a/src/test/modules/test_ddl_deparse/test_ddl_deparse.c b/src/test/modules/test_ddl_deparse/test_ddl_deparse.c
index 64a1dfa9f79..2159f78dde6 100644
--- a/src/test/modules/test_ddl_deparse/test_ddl_deparse.c
+++ b/src/test/modules/test_ddl_deparse/test_ddl_deparse.c
@@ -315,6 +315,12 @@ get_altertable_subcmdinfo(PG_FUNCTION_ARGS)
 			case AT_ReAddStatistics:
 				strtype = "(re) ADD STATS";
 				break;
+			case AT_SetIndexVisible:
+				strtype = "SET VISIBLE";
+				break;
+			case AT_SetIndexInvisible:
+				strtype = "SET INVISIBLE";
+				break;
 		}
 
 		if (subcmd->recurse)
